// File created 03/15/2015 with four space tab spacing

/** \file
	\brief step timer management
*/

#include "step_timer.h"
#include "simpletools.h"
#include "dda_queue.h"

/// cog variables
static int cog = 0;
static int stack[60];

/// time until next step
static uint32_t next_step_time;

void step_timer(void *par);

/// initialise timer
void step_timer_init()
{
	next_step_time = 0;

	if(cog == 0)
	{
		cog = 1 + cogstart(&step_timer, NULL, stack, sizeof stack);
	}
}

/// stop timer
void step_timer_stop()
{
	if(cog > 0)
	{
		cogstop(cog - 1);
		cog = 0;
	}
}

/// main loop for queueing step
void step_timer(void *par)
{
	while(1)
	{
		waitcnt(next_step_time);
 
		// Check if this is a real step, or just passing time
		if(next_step_time > 0)
		{
			queue_step();
			next_step_time = 0;
		}
	}
}

/// Initialize the next step
void setTimer(uint32_t delay)
{
	next_step_time = (delay += CNT);
}